# generated from catkin/cmake/template/pkgConfig.cmake.in

# append elements to a list and remove existing duplicates from the list
# copied from catkin/cmake/list_append_deduplicate.cmake to keep pkgConfig
# self contained
macro(_list_append_deduplicate listname)
  if(NOT "${ARGN}" STREQUAL "")
    if(${listname})
      list(REMOVE_ITEM ${listname} ${ARGN})
    endif()
    list(APPEND ${listname} ${ARGN})
  endif()
endmacro()

# append elements to a list if they are not already in the list
# copied from catkin/cmake/list_append_unique.cmake to keep pkgConfig
# self contained
macro(_list_append_unique listname)
  foreach(_item ${ARGN})
    list(FIND ${listname} ${_item} _index)
    if(_index EQUAL -1)
      list(APPEND ${listname} ${_item})
    endif()
  endforeach()
endmacro()

# pack a list of libraries with optional build configuration keywords
# copied from catkin/cmake/catkin_libraries.cmake to keep pkgConfig
# self contained
macro(_pack_libraries_with_build_configuration VAR)
  set(${VAR} "")
  set(_argn ${ARGN})
  list(LENGTH _argn _count)
  set(_index 0)
  while(${_index} LESS ${_count})
    list(GET _argn ${_index} lib)
    if("${lib}" MATCHES "^(debug|optimized|general)$")
      math(EXPR _index "${_index} + 1")
      if(${_index} EQUAL ${_count})
        message(FATAL_ERROR "_pack_libraries_with_build_configuration() the list of libraries '${ARGN}' ends with '${lib}' which is a build configuration keyword and must be followed by a library")
      endif()
      list(GET _argn ${_index} library)
      list(APPEND ${VAR} "${lib}${CATKIN_BUILD_CONFIGURATION_KEYWORD_SEPARATOR}${library}")
    else()
      list(APPEND ${VAR} "${lib}")
    endif()
    math(EXPR _index "${_index} + 1")
  endwhile()
endmacro()

# unpack a list of libraries with optional build configuration keyword prefixes
# copied from catkin/cmake/catkin_libraries.cmake to keep pkgConfig
# self contained
macro(_unpack_libraries_with_build_configuration VAR)
  set(${VAR} "")
  foreach(lib ${ARGN})
    string(REGEX REPLACE "^(debug|optimized|general)${CATKIN_BUILD_CONFIGURATION_KEYWORD_SEPARATOR}(.+)$" "\\1;\\2" lib "${lib}")
    list(APPEND ${VAR} "${lib}")
  endforeach()
endmacro()

macro(_replace_drive_letter pathname)
  if("${ARGN}" STREQUAL "")
    if(${pathname})
      set(dletter $ENV{ROS_HOME_DRIVE})
      string(REGEX REPLACE "^[A-Z]:" "${dletter}" ${pathname} ${${pathname}})
    endif()
  endif()
endmacro()

if(rosconsole_bridge_CONFIG_INCLUDED)
  return()
endif()
set(rosconsole_bridge_CONFIG_INCLUDED TRUE)

# set variables for source/devel/install prefixes
if("FALSE" STREQUAL "TRUE")
  set(rosconsole_bridge_SOURCE_PREFIX C:/Ros4Win/base/ros_core/rosconsole_bridge)
  set(rosconsole_bridge_DEVEL_PREFIX C:/_build/ros_core/rosconsole_bridge/devel)
  set(rosconsole_bridge_INSTALL_PREFIX "")
  set(rosconsole_bridge_PREFIX ${rosconsole_bridge_DEVEL_PREFIX})
else()
  set(rosconsole_bridge_SOURCE_PREFIX "")
  set(rosconsole_bridge_DEVEL_PREFIX "")
  set(rosconsole_bridge_INSTALL_PREFIX R:/opt/ros/melodic)
  set(rosconsole_bridge_PREFIX ${rosconsole_bridge_INSTALL_PREFIX})
endif()

# warn when using a deprecated package
if(NOT "" STREQUAL "")
  set(_msg "WARNING: package 'rosconsole_bridge' is deprecated")
  # append custom deprecation text if available
  if(NOT "" STREQUAL "TRUE")
    set(_msg "${_msg} ()")
  endif()
  message("${_msg}")
endif()

# flag project as catkin-based to distinguish if a find_package()-ed project is a catkin project
set(rosconsole_bridge_FOUND_CATKIN_PROJECT TRUE)

if(NOT "include;C:/opt/local/include " STREQUAL " ")
  set(rosconsole_bridge_INCLUDE_DIRS "")
  set(_include_dirs "include;C:/opt/local/include")
  if(NOT "https://github.com/ros/rosconsole_bridge/issues " STREQUAL " ")
    set(_report "Check the issue tracker 'https://github.com/ros/rosconsole_bridge/issues' and consider creating a ticket if the problem has not been reported yet.")
  elseif(NOT "http://www.ros.org/wiki/rosconsole_bridge " STREQUAL " ")
    set(_report "Check the website 'http://www.ros.org/wiki/rosconsole_bridge' for information and consider reporting the problem.")
  else()
    set(_report "Report the problem to the maintainer 'Dirk Thomas <dthomas@osrfoundation.org>, Ioan Sucan <isucan@gmail.com>' and request to fix the problem.")
  endif()
  foreach(idir ${_include_dirs})
    if(WIN32)
      _replace_drive_letter(idir)
    endif()

    if(IS_ABSOLUTE ${idir} AND IS_DIRECTORY ${idir})
      set(include ${idir})
    elseif("${idir} " STREQUAL "include ")
      get_filename_component(include "${rosconsole_bridge_DIR}/../../../include" ABSOLUTE)
      if(NOT IS_DIRECTORY ${include})
        message(FATAL_ERROR "Project 'rosconsole_bridge' specifies '${idir}' as an include dir, which is not found.  It does not exist in '${include}'.  ${_report}")
      endif()
    else()
      message(FATAL_ERROR "Project 'rosconsole_bridge' specifies '${idir}' as an include dir, which is not found.  It does neither exist as an absolute directory nor in 'R:/opt/ros/melodic/${idir}'.  ${_report}")
    endif()
    _list_append_unique(rosconsole_bridge_INCLUDE_DIRS ${include})
  endforeach()
endif()

set(libraries "rosconsole_bridge;C:/opt/local/lib/console_bridge.lib")
foreach(library ${libraries})
  # keep build configuration keywords, target names and absolute libraries as-is
  if("${library}" MATCHES "^(debug|optimized|general)$")
    list(APPEND rosconsole_bridge_LIBRARIES ${library})
  elseif(${library} MATCHES "^-l")
    list(APPEND rosconsole_bridge_LIBRARIES ${library})
  elseif("${library}" MATCHES "^(opengl32|glu32)$")
    message("=== Skip ${library}")
  elseif("${library}" MATCHES "[.]*NOTFOUND$")
    message("=== Skip ${library}")
  elseif(TARGET ${library})
    list(APPEND rosconsole_bridge_LIBRARIES ${library})
  elseif(IS_ABSOLUTE ${library})
    if(WIN32)
      _replace_drive_letter(library)
    endif()
    list(APPEND rosconsole_bridge_LIBRARIES ${library})
  else()
    set(lib_path "")
    set(lib "${library}-NOTFOUND")
    # since the path where the library is found is returned we have to iterate over the paths manually
    foreach(path C:/opt/ros/melodic/lib;0;R:/opt/ros/melodic/lib)
      if(WIN32)
        _replace_drive_letter(path)
      endif()
      find_library(lib ${library}
        PATHS ${path}
        NO_DEFAULT_PATH NO_CMAKE_FIND_ROOT_PATH)
      if(lib)
        set(lib_path ${path})
        break()
      endif()
    endforeach()
    if(lib)
      _list_append_unique(rosconsole_bridge_LIBRARY_DIRS ${lib_path})
      list(APPEND rosconsole_bridge_LIBRARIES ${lib})
    else()
      # as a fall back for non-catkin libraries try to search globally
      find_library(lib ${library})
      if(NOT lib)
        message(FATAL_ERROR "Project '${PROJECT_NAME}' tried to find library '${library}'.  The library is neither a target nor built/installed properly.  Did you compile project 'rosconsole_bridge'?  Did you find_package() it before the subdirectory containing its code is included?")
      endif()
      list(APPEND rosconsole_bridge_LIBRARIES ${lib})
    endif()
  endif()
endforeach()

set(rosconsole_bridge_EXPORTED_TARGETS "")
# create dummy targets for exported code generation targets to make life of users easier
foreach(t ${rosconsole_bridge_EXPORTED_TARGETS})
  if(NOT TARGET ${t})
    add_custom_target(${t})
  endif()
endforeach()

set(depends "rosconsole")
foreach(depend ${depends})
  string(REPLACE " " ";" depend_list ${depend})
  # the package name of the dependency must be kept in a unique variable so that it is not overwritten in recursive calls
  list(GET depend_list 0 rosconsole_bridge_dep)
  list(LENGTH depend_list count)
  if(${count} EQUAL 1)
    # simple dependencies must only be find_package()-ed once
    if(NOT ${rosconsole_bridge_dep}_FOUND)
      find_package(${rosconsole_bridge_dep} REQUIRED NO_MODULE)
    endif()
  else()
    # dependencies with components must be find_package()-ed again
    list(REMOVE_AT depend_list 0)
    find_package(${rosconsole_bridge_dep} REQUIRED NO_MODULE ${depend_list})
  endif()
  _list_append_unique(rosconsole_bridge_INCLUDE_DIRS ${${rosconsole_bridge_dep}_INCLUDE_DIRS})

  # merge build configuration keywords with library names to correctly deduplicate
  _pack_libraries_with_build_configuration(rosconsole_bridge_LIBRARIES ${rosconsole_bridge_LIBRARIES})
  _pack_libraries_with_build_configuration(_libraries ${${rosconsole_bridge_dep}_LIBRARIES})
  _list_append_deduplicate(rosconsole_bridge_LIBRARIES ${_libraries})
  # undo build configuration keyword merging after deduplication
  _unpack_libraries_with_build_configuration(rosconsole_bridge_LIBRARIES ${rosconsole_bridge_LIBRARIES})

  _list_append_unique(rosconsole_bridge_LIBRARY_DIRS ${${rosconsole_bridge_dep}_LIBRARY_DIRS})
  list(APPEND rosconsole_bridge_EXPORTED_TARGETS ${${rosconsole_bridge_dep}_EXPORTED_TARGETS})
endforeach()

set(pkg_cfg_extras "")
foreach(extra ${pkg_cfg_extras})
  if(NOT IS_ABSOLUTE ${extra})
    set(extra ${rosconsole_bridge_DIR}/${extra})
  endif()
  include(${extra})
endforeach()
